/* 
	FILEMANAGER  --  A FREE CROSS-PLATFORM XUL-BASED FILE MANAGEMENT TOOL
	Author: Duong Thanh An - dgthanhan@gmail.com (core)
	Co-author: Le Phong "Apache" Bao Vuong - apache@7bit.biz (php module)

	Copyright (C) 2004 Anisolution.com

	This library is free software; you can redistribute it and/or
	modify it under the terms of the GNU Lesser General Public
	License as published by the Free Software Foundation; either
	version 2.1 of the License, or (at your option) any later version.

	This library is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
	Lesser General Public License for more details.

	You should have received a copy of the GNU Lesser General Public
	License along with this library; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Anisolution.com
	http://www.anisolution.com
	HCMC Vietnam
	Duong Thanh An
	dgthanhan@gmail.com


	$Id: History.js,v 1.1 2004/11/27 11:58:05 thanh.an Exp $

*/

//A stack-based implemetation for history

function History(){
	this.pos = -1;
	this.urls = new Array();
	this.enable = true;

	this.isEmpty = function() {
		return (this.urls.length == 0);
	};
	this.canGoBack = function() {
		return (this.pos > 0);
	};
	this.canGoNext = function() {
		return (this.pos < this.urls.length - 1);
	};
	this.next = function () {
		if(!this.canGoNext()) return null;
		this.pos ++;
		return this.urls[this.pos];
	};
	this.back = function () {
		if(!this.canGoBack()) return null;
		this.pos --;
		return this.urls[this.pos];
	};
	this.empty = function() {
		this.pos = -1;
		this.urls.length = 0;
	}
	this.put = function (url) {
		if(!this.enable) {
			this.enable = true;
			return;
		}
		if(this.pos >= 0 && this.urls[this.pos] == url) return;
		this.pos ++;
		this.urls.length = this.pos + 1;
		this.urls[this.pos] = url;
		return url;
	}

	this.empty();
}