<?php include_once "includes/config.php"; ?>
<?php include_once "includes/xml-header.php"; ?>
<?php include_once "includes/util_lib.php"; ?>
<?php
/* 
	FILEMANAGER  --  A FREE CROSS-PLATFORM XUL-BASED FILE MANAGEMENT TOOL
	Author: Duong Thanh An - dgthanhan@gmail.com (core)
	Co-author: Le Phong "Apache" Bao Vuong - apache@7bit.biz (php module)

	Copyright (C) 2004 Anisolution.com

	This library is free software; you can redistribute it and/or
	modify it under the terms of the GNU Lesser General Public
	License as published by the Free Software Foundation; either
	version 2.1 of the License, or (at your option) any later version.

	This library is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
	Lesser General Public License for more details.

	You should have received a copy of the GNU Lesser General Public
	License along with this library; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Anisolution.com
	http://www.anisolution.com
	HCMC Vietnam
	Duong Thanh An
	dgthanhan@gmail.com


	$Id: common-actions.php,v 1.1 2004/11/27 11:58:29 thanh.an Exp $

*/
	
	$action = util_request($P_ACTION, "");
	$path1 = getOrignialRealPath1();
	$success = true;
	$errorCode = "";
	$errorDescription = "";
	$successXML = "";

	switch ($action)
	{	
		case "createFile":
			if (! is_file($path1) && ! is_dir($path1)) 
			{
				$handle = fopen ($path1, "w") or die(writeErrorMessage("Error","Error in createFile"));
				fclose ($handle);				
			}	
			else {
				$success = false;
				die(writeErrorMessage("Error","File exist"));
			}
			break;
		
		case "createFolder":	
			if (! is_dir($path1))
				mkdir($path1) or die(writeErrorMessage("Error","Error in createFolder"));
			else {
				$success = false;
				die(writeErrorMessage("Error","Folder exist"));
			}	
			break;

		case "copy":			
			$path1 = getOrignialRealPath1(false);
			$path2 = getOrignialRealPath2();
			$selection = "";
			
			if ($path1 != "") 
			{
				$arr = explode("\n",$path1);

				foreach ($arr as $item)
				{
					$item = $ROOT_PATH.$item;

					$dir_path = dirname($item);
					$name = basename ($item);					
					$save_name = $name; 
					
					//if the source is in the same folder, using the "Copy of " scheme
					if ($dir_path.DIRECTORY_SEPARATOR==$path2) 
					{
						$count = 1;
						$save_name=getCopyNText($name, $count);

						while (file_exists($dir_path.DIRECTORY_SEPARATOR.$save_name)) {
							$count++;
							$save_name=getCopyNText($name, $count);
						}						
					}									
 
					if (is_dir($item)) {						
						copyFolder($item,$path2,$save_name);						
					} 
					else 
					{
						if (!copy ($item,$path2.DIRECTORY_SEPARATOR.$save_name))
							die(writeErrorMessage("Error","Couldn't copy file: ".$item));	
					}
					
					$selection .= ($selection=="")?"":"\n";
					$selection .= unMapPath($path2.$save_name);
				}
			}
			
			if ($selection != "") $successXML = "<selection>" .htmlspecialchars($selection). "</selection>";

			break;
			
		case "delete":
			$path1 = getOrignialRealPath1(false);

			if ($path1 != "") 
			{			
				$arr = explode("\n",$path1);
				foreach ($arr as $item)
				{
					$item = $ROOT_PATH.$item;
					if (is_dir($item)) {
						deleteFolder($item);
					} else {
						chmod($item,0777);					
						unlink($item);
					}	
				}
			}

			break;
			
		case "move":
			$path1 = getOrignialRealPath1(false);
			$path2 = getOrignialRealPath2();
			
			if ($path1 != "") 
			{
				$arr = explode("\n",$path1);

				foreach ($arr as $item)
				{
					$item = $ROOT_PATH.$item;
					$name = basename ($item);
				
					rename($item,$path2.DIRECTORY_SEPARATOR.$name);
				}
			}
			
			break;
		
		case "moveWithNewName":
			$path2 = getOrignialRealPath2();			
			rename($path1,$path2);
			
			break;
			
		default:
			$success = false;
			die(writeErrorMessage("Error","Action not found"));
	}

	if ($success) echo getSuccessMessage($successXML);
?>